package Tienda;

import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.*;

import java.util.*;

import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;

public class cliente extends Agent {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	protected void setup() {
		System.out.println("En la tienda del pueblo...");
		SequentialBehaviour seqBehaviour = new SequentialBehaviour();
		seqBehaviour.addSubBehaviour(new MyThreeStepBehaviour());
		seqBehaviour.addSubBehaviour(new TickerBehaviour(this, 100) {
			/**
			 * 
			 */
			private static final long serialVersionUID = 1L;

			protected void onTick() {
				recibirHijo();
				recibirSegurata();
			}
		});
		addBehaviour(seqBehaviour);
	}

	protected void takeDown() {
		ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
		msg.addReceiver(new AID("nio", AID.ISLOCALNAME));
		msg.setContent("fin");
		send(msg);
		System.out.println("(" + getLocalName()
				+ ") Papa sale de la tienda con el hijo");
	}

	public class MyThreeStepBehaviour extends Behaviour {
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		private int step = 0;

		public void onStart() {
			System.out.println("(" + getLocalName() + ")"
					+ " entra en la tienda.");
		}

		public void action() {
			switch (step) {
			case 0:
				desbloquearHijo();
				block(100);
				step++;
				break;
			case 1:
				desbloquearSegurata();
				block(100);
				step++;
				break;
			case 2:
				desbloquearVendedor();
				block(100);
				step++;
				break;
			}
		}

		public boolean done() {
			return step == 3;
		}

		private int desbloquearHijo() {
			ACLMessage msg = new ACLMessage(ACLMessage.REQUEST);
			msg.addReceiver(new AID("nio", AID.ISLOCALNAME));
			msg.setContent("vamos");
			send(msg);
			return 1;
		}

		private int desbloquearSegurata() {
			ACLMessage msg = new ACLMessage(ACLMessage.REQUEST);
			msg.addReceiver(new AID("segurata", AID.ISLOCALNAME));
			msg.setContent("vamos");
			send(msg);
			return 1;
		}

		private int desbloquearVendedor() {
			ACLMessage msg = new ACLMessage(ACLMessage.REQUEST);
			msg.addReceiver(new AID("vendedor", AID.ISLOCALNAME));
			msg.setContent("vamos");
			send(msg);
			return 1;
		}
	}

	private int recibirHijo() {
		ACLMessage msg = blockingReceive(MessageTemplate
				.MatchPerformative(ACLMessage.INFORM));
		if (msg.getContent().equalsIgnoreCase("cereales")) {
			System.out.println("(" + getLocalName()
					+ ") De acuerdo hijo, te compro los cereales");
		}
		return 1;
	}
	
	private int recibirSegurata(){
		ACLMessage msg2 = blockingReceive(MessageTemplate.MatchPerformative(ACLMessage.INFORM));
		if(msg2.getContent().equalsIgnoreCase("fin")){
			doDelete();
		}
		return 1;
	}
}
